import kotlin.math.roundToInt
import java.io.File
const val TAVERN_NAME = "Taernyl's Folly"

var playerGold = 10
var playerSilver = 10
val patronList = mutableListOf("Eli", "Mordoc", "Sophie")
val lastName = listOf("Ironfoot", "Fernsworth", "Baggins")
val uniquePatrons = mutableSetOf<String>()
val menuList = File("data/tavern-menu-items.txt")
        .readText()
        .split("\r\n")
val patronGold = mapOf("Eli" to 10.5, "Mordoc" to 8.0, "Sophie" to 5.5)

fun main() {
    if (patronList.contains("Eli")) {
        println("The tavern master says: Eli's in the back playing cards.")
    } else {
        println("The tavern master says: Eli isn't here.")
    }
    if (patronList.containsAll(listOf("Sophie", "Mordoc"))) {
        println("The tavern master says: Yea, they're seated by the stew kettle.")
    } else {
        println("The tavern master says: Nay, they departed hours ago.")
    }

    // printMenu()
    printMenu2()

    (0..9).forEach {
        val first = patronList.shuffled().first()
        val last = lastName.shuffled().first()
        val name = "$first $last"
        uniquePatrons += name
    }
    println(uniquePatrons)

    var orderCount = 0
    while (orderCount <= 9) {
        placeOrder(uniquePatrons.shuffled().first(),
                menuList.shuffled().first())
        orderCount++
    }
    println(patronGold)
}

fun printMenu()
{
    // Вставляем пустую строку,
    // чтобы отделить заголовок меню
    println()
    // Заголовок меню
    val hello = "*** Welcome to Taernyl's Folly ***"
    // Количество символов в заголовке меню
    val cnt = hello.count()
    // Выводим заголовок меню
    println(hello)
    println() // Пустая строка
    // Цикл по количеству элементов меню
    menuList.forEach {t ->
        // "Разбирем" строку меню на элементы
        val (_, name, price) = t.split(',')
        // Делаем первую букву названия заглавной
        val nameOut = name[0].toUpperCase() + name.substring(1, name.count())
        // Определяем, сколько символов после десятичной точки
        val pos = price.indexOf('.')
        // Если он один, то добавляем 0
        val priceOut = if (price.count() - pos == 2) {
            price + '0'
        } else {
            price
        }
        // Дополняем название пункта меню нужным количество точек
        val s = nameOut.padEnd(cnt - priceOut.count(), '.')
        // Печатаем пункт меню с точками, дополненный ценой
        println(s + priceOut)
    }
    println() // Пустая строка для отделения меню
}

fun printMenu2()
{
    // Вставляем пустую строку,
    // чтобы отделить заголовок меню
    println()
    // Заголовок меню
    val hello = "*** Welcome to Taernyl's Folly ***"
    // Количество символов в заголовке меню
    val cnt = hello.count()
    // Выводим заголовок меню
    println(hello)
    // Создаем изменяемый список с видами элементов меню
    val typeList = mutableListOf<String>()
    // Цикл по количеству элементов меню
    menuList.forEach {t ->
        // "Разбирем" строку меню на элементы
        val (type, _, _) = t.split(',')
        // Если такого элемента нет...
        if (typeList.contains(type) == false)
        {
            // ... добавляем его в список
            typeList.add(type)
            //Формируем и выводим заголовок вида
            val titleType = "           ~["+ type + "]~"
            println(titleType)
            // Ищем все записи в таким видом
            menuList.forEach { tt ->
                val (type2, name, price) = tt.split(',')
                // Если вид текущей записи совпадает с выбранным...
                if (type == type2)
                {
                    // ... выводим его в меню
                    // Делаем первую букву названия заглавной
                    val nameOut = name[0].toUpperCase() + name.substring(1, name.count())
                    // Определяем, сколько символов после десятичной точки
                    val pos = price.indexOf('.')
                    // Если он один, то добавляем 0
                    val priceOut = if (price.count() - pos == 2) {
                        price + '0'
                    } else {
                        price
                    }
                    // Дополняем название пункта меню нужным количество точек
                    val s = nameOut.padEnd(cnt - priceOut.count(), '.')
                    // Печатаем пункт меню с точками, дополненный ценой
                    println(s + priceOut)
                }
            }
        }

    }
    println() // Пустая строка для отделения меню
}


fun performPurchase(price: Double) {
    displayBalance()
    val totalPurse = playerGold + (playerSilver / 100.0)
    println("Total purse: $totalPurse")
    println("Purchasing item for $price")

    val remainingBalance = totalPurse - price
    val remainingGold = remainingBalance.toInt()
    val remainingSilver = (remainingBalance % 1 * 100).roundToInt()
    playerGold = remainingGold
    playerSilver = remainingSilver
    displayBalance()
}

private fun displayBalance() {
    println("Player's purse balance: Gold: $playerGold , Silver: $playerSilver")
}

private fun placeOrder(patronName: String, menuData: String) {
    val indexOfApostrophe = TAVERN_NAME.indexOf('\'')
    val tavernMaster = TAVERN_NAME.substring(0 until indexOfApostrophe)
    println("$patronName speaks with $tavernMaster about their order.")
    val (type, name, price) = menuData.split(',')
    val message = "$patronName buys a $name ($type) for $price."
    println(message)

    // performPurchase(price.toDouble())

    val phrase = if (name == "Dragon's Breath") {
        "$patronName exclaims: ${toDragonSpeak("Ah, delicious $name!")}"
    } else {
        "$patronName says: Thanks for the $name."
    }
    println(phrase)
}

private fun toDragonSpeak(phrase: String) =
        phrase.replace(Regex("[aeiouAEIOU]")) {
            when (it.value) {
                "a", "A" -> "4"
                "e", "E" -> "3"
                "i", "I" -> "1"
                "o", "O" -> "0"
                "u", "U" -> "|_|"
                else -> it.value
            }
}